#!/bin/sh

# bb-msgs.sh
#
# BIG BROTHER MONITORING SCRIPT
# Sean MacGuire - BB4 Technologies
# Version 1.5a
# Aug 24th, 2000
#
# This program is Copyright (c) 1997-2000
# BB4 Technologies Inc
# All Rights Reserved
#
# echo "***** BBHOME IS SET TO $BBHOME"
# echo "***** BBTMP IS SET TO $BBTMP"

if test ! "$BBTMP"                      # GET DEFINITIONS IF NEEDED
then
	 # echo "*** LOADING BBDEF ***"
        . $BBHOME/etc/bbdef.sh          # INCLUDE STANDARD DEFINITIONS
fi

if test ! "$MACHINEDOTS"		# THIS SHOULD ALREADY BE SET...
then
	# Setup the name of the local host
	# Save a version of the machine name with '.' 
	# instead of ',', if any are there
	MACHINEDOTS=`echo $MACHINE | $SED 's/,/\./g'`
	if [ "$FQDN" != "TRUE" ]
	then
		OLDIFS=$IFS
		IFS='.'
		set $MACHINEDOTS >/dev/null
		IFS=$OLDIFS
		MACHINEMASK="${1}"
	else
		MACHINEMASK="${MACHINEDOTS}"
	fi
	export MACHINEDOTS MACHINEMASK
fi

#=====================================================================
# NOTIFY ON BAD MESSAGES
#=====================================================================
#
# echo "*** MESSAGES TEST ***"

BADMSGFILE=""
for file in $MSGFILE
do
	if test ! -r "$file" 	# FILE IS NOT READABLE, ALWAYS AN ERROR
	then
		BADMSGFILE="$BADMSGFILE $file"
	elif test "$CHKMSGLEN" = "TRUE"
	then
		if [ ! -s "$file" ]	# FILE IS EMPTY!
		then
			BADMSGFILE="$BADMSGFILE $file"
		fi
	fi
done

# Are there any bad message files
BADLINE=""
if [ "$BADMSGFILE" = "" ]
then

	COLOR="green"
	MSGLINE="No bad messages"
	
	msgsfile=$BBTMP/BBMSG.$$
	for word in $MSGS
	do
        	$GREP "$word" $MSGFILE > $msgsfile
        	if [ "$?" -eq 0 ]                       # FOUND A BAD WORD
        	then
                	OLDIFS=$IFS
                	IFS=";"
                	for ignmsg in $IGNMSGS
                	do
                        	# Save in a file to keep new lines
                        	$GREP -v "$ignmsg" $msgsfile > ${msgsfile}.tmp
                        	mv ${msgsfile}.tmp ${msgsfile}
                	done
                	IFS=$OLDIFS
                	if [ ! -s "${msgsfile}" ]
                	then
                        	continue
                	fi
                	LINE=`cat ${msgsfile} | $TAIL -10`
			MSGLINE="$MACHINE - bad message(s) found:
		
"
			BADLINE="${BADLINE}${LINE}"
			echo "$PAGEMSG" | $GREP "$word" > /dev/null 2>&1
			if test "$?" = "0"
			then
				COLOR="red"
				break;			# ENOUGH ALREADY...
			else
				if test "$COLOR" = "green"
				then
					COLOR="yellow"
				fi
			fi
		fi
	done
else					# PROBLEM WITH THE MESSAGE FILE
	COLOR="red"
	MSGLINE=""
	for file in $BADMSGFILE
	do
		# DOES THE FILE EXIST ?
		if [ ! -f $file ] 
		then
			MSGLINE="$MSGLINE
$file has vanished"
		elif [ ! -r $file ] 	# READABLE
		then
			MSGLINE="$MSGLINE
$file is unreadable"
		else
			MSGLINE="$MSGLINE
$file is empty"
		fi
	done
fi
$RM -f ${msgsfile}

$BB $BBDISP "status $MACHINE.msgs $COLOR `date` ${MSGLINE}${BADLINE}"
